#include "messiahC4Dglobals.h"
#include "messiahC4Dconstants.h"
#include <stdio.h>

// returns a messiah deform tag attached to an object, or NULL if none exists
PluginTag* GetMessiahDformTag(BaseObject* obj)
{
  BaseTag* tag = obj->GetFirstTag();

  while ( tag && !(tag->GetType() == ID_MESSIAH_DEFORM_TAG) )
  {
    tag = tag->GetNext();
  }
  
  return static_cast<PluginTag*>(tag);
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// gets the persistent object that op is a cache of
BaseObject * GetPersistentObj( BaseObject *op )
{
	BaseObject* parent = op;

	while (true)
	{
		BaseObject* temp = parent->GetCacheParent();
		if (temp) parent = temp;
		else break;
	}

	return parent;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
