#define MHLIB_ALL
#include <mhlib/mhlib.h>


////////////////////////////////////////////////////////////////////////////
/*
			messiahC4Dscene_events_handler
*/
////////////////////////////////////////////////////////////////////////////
// Handles messages sent from messiah
class messiahC4Dscene_events_handler : public mh::scene_events
{
public:

	//		called when the user changes the content directory in messiah
	//		not really applicable to c4d
	bool setContentDirectory( char const *dir, int buffer_length, int flags ) { return true; }

	//		called when messiah needs you to suply geometry for an object
	bool geometryCopy( mh::object &obj, int flags );

	//		called when messiah needs to update *only* the position of the vertices for an object
	bool getPoints( mh::object &obj, int flags ) { return true; }

	//		called when the user changes an objects name in messiah
	bool objectRename( mh::object &obj, int flags );

	//		called when messiah is exporting an object to c4d
	void * constructObject( mh::object &obj, int flags );

	//		called when messiah is attaching a plugin (i.e. mover/deformer) to a c4d object
	mh::object * addPlugin( mh::object &obj, void *data, int plug_type, int flags);

};