#include "messiahC4Dclasses.h"
#include "messiahC4Dmhobject.h"
#include "messiahC4Dglobals.h"
#include "messiahSceneHook.h"
#include <stdio.h>

#define MHLIB_ALL
#include <mhlib/mhlib.h>

#include <vector>
#include <algorithm>

extern mh::module *	messiahHost;
extern char				progName[];
extern char				plugName[];
extern bool				messiah_loaded;

std::vector<mC4Dmhobject *>		freed_list;


// Initialize Tag (::Init)  /////////////////////////////////////////////////////////////////////////////////////

Bool messiahDformTag::Init(GeListNode *node)
{
	return TRUE;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Cleanup Tag (::Free)  /////////////////////////////////////////////////////////////////////////////////////

void messiahDformTag::Free(GeListNode *node)
{

}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Save Tag (::Write)  /////////////////////////////////////////////////////////////////////////////////////////

Bool messiahDformTag::Write(GeListNode *node, HyperFile *hf)
{
	if( !messiah_loaded ) return FALSE;

	if( !messiahHost->getScene()->isSaving() )
	{
		messiahHost->getScene()->prepareForSave();
	}

	PluginTag *tag = static_cast<PluginTag *>(node) ;
	BaseContainer *cont, *data;

	if( ( cont = tag->GetDataInstance()) )
	{
		if( ( data = cont->GetContainerInstance( ID_MESSIAH_DATA_ATTACH)) ) 
		{

			mC4Dmhobject * mh_obj = reinterpret_cast<mC4Dmhobject *>(data->GetLong( ID_MH_OBJ_PTR ));
			if(!mh_obj) return FALSE;


			hf->WriteLong( mh_obj->d_ID );

		}
	}

	return TRUE;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Load Tag (::Read)  /////////////////////////////////////////////////////////////////////////////////////////

Bool messiahDformTag::Read(GeListNode *node, HyperFile *hf, LONG level )
{
	if( !messiah_loaded ) return FALSE;

	// If messiah is not loaded, do so now
	// This will avoid the overhead of loading messiah until the user needs it
	if( !messiahHost->isMessiahActive() )
		if( !messiahHost->startup( progName, plugName ) )
		{
			GePrint("Error loading messiah! messiahC4D will not work properly!");
		}

	if( !messiahHost->getScene()->isLoading() )
	{
		messiahHost->getScene()->prepareForLoad();
	}

	mC4Dmhobject *mh_obj = NULL;	// derived from mh::object

	mh_obj = new mC4Dmhobject;
	mh_obj->loading = true;

	hf->ReadLong( (LONG *)(&mh_obj->d_ID) );

	BaseTag *tag = static_cast<PluginTag *>(node);
	BaseContainer newCont, *cont;

	cont = tag->GetDataInstance();

	newCont.SetLong( ID_MH_OBJ_PTR, reinterpret_cast<LONG>(mh_obj) );
	cont->SetContainer( ID_MESSIAH_DATA_ATTACH, newCont );

	BaseObject *obj = tag->GetObject();

	// establish link between host plugin object and messiah object
	String sname = obj->GetName();
	char *name = new char[sname.GetCStringLen()+1];
	sname.GetCString( name, sname.GetCStringLen()+1 );

	messiahHost->getScene()->connectLoadingObj( mh_obj, mh_obj->d_ID );
	mh_obj->setPluginType( mh::object::Displacement );

//	object_loaded( messiahHost->getScene() );

	return TRUE;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Register Messiah Deform Tag Plugin  /////////////////////////////////////////////////////////////////////////

Bool RegisterMessiahDeformTag(void)
{
	String name;
	name = GeLoadString(IDS_MESSIAH_DEFORMER_TAG);

	if( !RegisterTagPlugin( ID_MESSIAH_DEFORM_TAG, name, TAG_VISIBLE, messiahDformTag::Alloc, "", "messiah.bmp", 0) )
		return FALSE;

	return TRUE;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
