#include "messiahSceneHook.h"


#include "messiahC4Dclasses.h"
#include "messiahC4Dglobals.h"
#include "messiahC4Dmhobject.h"

#include <cstring>

extern mh::module *		messiahHost;
extern char				progName[];
extern char				plugName[];
extern bool				messiah_loaded;

char *					fxs_buffer = NULL;
long					num_objects_loaded = 0;
long					num_objects_to_load = 0;
/*
void	begin_object_loading(long num)
{
	num_objects_loaded = 0;
	num_objects_to_load = num;
}

void	last_host_object_loaded(mh::scene *scene)
{
	if(!scene)return;

	scene->finalizeLoad();
	
	if( fxs_buffer )
		GeFree(fxs_buffer);
	
	fxs_buffer = NULL;
}

void	object_loaded(mh::scene *scene)
{
	num_objects_loaded++;
	
//	if( num_objects_loaded == num_objects_to_load )
//		last_host_object_loaded( scene );
}
*/

#include <fstream>

class messiahSceneHook : public SceneHookData
{
INSTANCEOF(messiahSceneHook,CustomDataTypeClass)
public:

	messiahSceneHook() {}
	~messiahSceneHook()
	{
//		mh::scene * scn = this->GetScene();
//		if( scn )
//			scn->clearScene();

	}

	virtual Bool Read(GeListNode *node, HyperFile *hf, LONG level)
	{
	
		if( !messiah_loaded ) return TRUE;

		// Get the mh::scene from the scene hook
		mh::scene* docscene = this->GetScene();
		if (!docscene) return FALSE;

		if( !docscene->isLoading() )
		{
			docscene->prepareForLoad();
		}
				
		if (level >= 0)
		{
			Bool initialized = FALSE;
			hf->ReadBool(&initialized);
			
			if (initialized)
			{
				// If messiah is not loaded, do so now
				// This will avoid the overhead of loading messiah until the user needs it
				if( !messiahHost->isMessiahActive() )
					if( !messiahHost->startup( progName, plugName ) )
					{
						GePrint("Error loading messiah! messiahC4D will not work properly!");
					}
				
				
				LONG	len;

				hf->ReadMemory( (void **)(&fxs_buffer), &len );
//				std::ofstream log("messiahC4D_fxsbuffer.txt");
//				log << fxs_buffer;
//				log.close();
				
				docscene->fxsBuffer( fxs_buffer );

				docscene->finalizeLoad();	
				GeFree( fxs_buffer );
			}

		}

		return TRUE;
	}
	
	virtual Bool Write(GeListNode *node, HyperFile *hf)
	{
		if( !messiah_loaded ) return TRUE;

		// Get the mh::scene from the scene hook
		mh::scene* docscene = this->GetScene();
		if (!docscene) return FALSE;

		if( !docscene->isSaving() )
		{
			docscene->prepareForSave();
		}

		Bool initialized = (messiahHost && messiahHost->isMessiahActive());

		hf->WriteBool( initialized );

		if ( initialized )
		{
			char const *buffer = docscene->fxsBuffer();
			LONG		len = ::strlen( buffer ) + 1;

			hf->WriteMemory( (void *)buffer, len );
		}		

		docscene->finalizeSave();

		return TRUE;
	}
	
	virtual Bool CopyTo(NodeData *dest, GeListNode *snode, GeListNode *dnode, LONG flags, AliasTrans *trn)
	{
		if (!dest)
		{
			return FALSE;
		}
		else
		{
			*static_cast<messiahSceneHook*>(dest) = *this;
		}
		
		return TRUE;
	}


	virtual LONG InitSceneHook(PluginSceneHook *node, BaseDocument *doc, BaseThread *bt)
	{
		if (messiah_loaded && messiahHost && messiahHost->isMessiahActive())
		{
			BaseTime t = doc->GetTime();
			LONG fps = doc->GetFps();
			messiahHost->setTime( (double)t.GetFrame( fps ) );
		}

		return EXECUTION_RESULT_OK;
	}

	static NodeData* Alloc() { return gNew messiahSceneHook; }

	Bool InitScene()
	{
		return TRUE;
	}

	void ClearScene()
	{
	}

	mh::scene* GetScene()
	{
		return messiahHost->getScene();
	}
};

mh::scene* GetMessiahSceneFromDocument(BaseDocument& doc)
{
	PluginSceneHook* psh = doc.FindSceneHook(ID_MESSIAH_SCENE_HOOK);
	if (!psh) return NULL;

	messiahSceneHook* sh = static_cast<messiahSceneHook*>(psh->GetNodeData());
	if (!sh) return NULL;

	return sh->GetScene();
}

Bool RegisterMessiahSceneHook()
{
	return RegisterSceneHookPlugin(ID_MESSIAH_SCENE_HOOK, "Messiah Scene Hook", 
														 PLUGINFLAG_HIDE, 
														 messiahSceneHook::Alloc,
														 EXECUTION_INITIAL,
														 0);
}