// ==================			DllEntry.cpp		==============
//
// Copyright (C) 2002 pmG Worldwide LLC. All Rights Reserved.
//
// ===============================================================
//
// Description:
//
// Entry point for the plugin. See messiahMAX.def for list of 
// exported symbols.
//
// ===============================================================
//
// Version History:
//
// Written By: Lyle Milton
//
// Revised By: Ron Griswold
// Date: 5/19/02
//
// ===============================================================
#define HOST_MODULE
#include "messiahMAX.h"

extern ClassDesc2*	GetmessiahMAXDesc();		// defined in messiahMAX.cpp
extern ClassDesc2*	GetmessiahMAXcontrollerDesc();
extern ClassDesc*	GetmessiahMAXUtilClassDesc();
// ===============================================================
// Globals
// ===============================================================
int			controlsInit = FALSE;
HINSTANCE	hInstance;

// ===============================================================
// DLLMain
// ===============================================================
BOOL WINAPI DllMain(HINSTANCE hinstDLL,ULONG fdwReason,LPVOID lpvReserved)
{
	hInstance = hinstDLL;				// Hang on to this DLL's instance handle.

	if (!controlsInit)
	{
		controlsInit = TRUE;

 		if (!hostLoadmessiahHOST()) return FALSE;


		InitCustomControls(hInstance);	// Initialize MAX's custom controls
		InitCommonControls();			// Initialize Win95 controls
		RegisterNotification(NotifyPreLoad, NULL, NOTIFY_FILE_PRE_OPEN);
		RegisterNotification(NotifyPostLoad, NULL, NOTIFY_FILE_POST_OPEN);
		RegisterNotification(NotifyPreSave, NULL, NOTIFY_FILE_PRE_SAVE);
		RegisterNotification(NotifyPostSave, NULL, NOTIFY_FILE_POST_SAVE);
		RegisterNotification(NotifyPreMerge, NULL, NOTIFY_FILE_PRE_MERGE);
		RegisterNotification(NotifyPostMerge, NULL, NOTIFY_FILE_POST_MERGE);
		RegisterNotification(NotifyPreReset, NULL, NOTIFY_SYSTEM_PRE_RESET);
		RegisterNotification(NotifyPostReset, NULL, NOTIFY_SYSTEM_POST_RESET);
		RegisterNotification(NotifyPreNew, NULL, NOTIFY_SYSTEM_PRE_NEW);
		RegisterNotification(NotifyPostNew, NULL, NOTIFY_SYSTEM_POST_NEW);
		RegisterNotification(NotifySystemShutdown, NULL, NOTIFY_SYSTEM_SHUTDOWN);
	}
			
	return (TRUE);
}

// ===============================================================
// LibDescription
// ===============================================================
// This function returns a string that describes the DLL and where the user
// could purchase the DLL if they don't have it.
__declspec( dllexport ) const TCHAR* LibDescription()
{
	return GetString(IDS_LIBDESCRIPTION);
}

// ===============================================================
// LibNumClasses
// ===============================================================
// This function returns the number of plug-in classes this DLL
//TODO: Must change this number when adding a new class
__declspec( dllexport ) int LibNumberClasses()
{
	return 3;
}

// ===============================================================
// LibClassDesc
// ===============================================================
// This function returns the number of plug-in classes this DLL
__declspec( dllexport ) ClassDesc* LibClassDesc(int i)
{
	switch(i) {
		case 0: return GetmessiahMAXDesc();
			break;
		case 1: return GetmessiahMAXcontrollerDesc();
			break;
		case 2: return GetmessiahMAXUtilClassDesc();
			break;
		default: return 0;
	}
}

// ===============================================================
// LibVersion
// ===============================================================
// This function returns a pre-defined constant indicating the version of 
// the system under which it was compiled.  It is used to allow the system
// to catch obsolete DLLs.
__declspec( dllexport ) ULONG LibVersion()
{
	return VERSION_3DSMAX;
}

TCHAR *GetString(int id)
{
	static TCHAR buf[256];

	if (hInstance)
		return LoadString(hInstance, id, buf, sizeof(buf)) ? buf : NULL;
	return NULL;
}

