#ifdef _WIN32
	#include <windows.h>            // Window defines
#endif



//Standard C Library Stuff--------------------------------------------
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#include <time.h>

#define MESSIAH_HOST_MODULE
#include "messiahHOST.h"


__EXPORTVAR(int) hostLoadmessiahHOST(void);
__EXPORTVAR(int) hostObjectRename(FX_NodeLog *nd, int flags);
__EXPORTVAR(int) hostObjectGeometryCopy(FX_NodeLog *nd, int add_to_hierarchy);
__EXPORTVAR(int) hostObjectGetPoints(FX_NodeLog *nd, int reset_object);
__EXPORTVAR(void) hostGlobalsGetAll(void);
__EXPORTVAR(int) hostLoadmessiahHOST(void);
__EXPORTVAR(void*)	hostObjectConstruct(int obj, int flags);
__EXPORTVAR(int)	hostAddPlugin(void *obj_data, int obj, int messiah_plugtype, int flags);

#define	HOST_SET(v)			if (!strcmp(#v,global_name)) return &##v
#define	MESSIAH_GET(v)		v = messiahGlobal(#v)

//---------------------------------------------------------------------------
//	Name:	hostGlobal
//	Purpose:Required global pointer send function.  Called from messiah.
//---------------------------------------------------------------------------
__EXPORTVAR(void*) hostGlobal(char *global_name)
{
	if (!global_name) return NULL;

	HOST_SET(hostObjectGeometryCopy);
	HOST_SET(hostObjectGetPoints);
	HOST_SET(hostObjectRename);
	HOST_SET(hostObjectConstruct);
	HOST_SET(hostAddPlugin);

	return NULL;
}


//---------------------------------------------------------------------------
//	Name:	hostGlobalsGetAll
//	Purpose:Required global pointer retrieval function.  Called from host.
//---------------------------------------------------------------------------
__EXPORTVAR(void) hostGlobalsGetAll(void)
{
	 MESSIAH_GET(messiah_current_frame);

	 MESSIAH_GET(messiah_Activated);
	 MESSIAH_GET(messiahStart);
	 MESSIAH_GET(messiahInterface);
	 MESSIAH_GET(messiahShutdown);
	 MESSIAH_GET(messiahCheckTime);
	 MESSIAH_GET(messiahUpdate);

	 MESSIAH_GET(messiahSceneFileCreateBuff);
	 MESSIAH_GET(messiahSceneFileLoadBuff);
	 MESSIAH_GET(messiahSceneLoad);
	 MESSIAH_GET(messiahSceneClear);
	 MESSIAH_GET(messiahSceneFileFilterBuff);
	 MESSIAH_GET(messiahSceneFileClearBuff);

	 MESSIAH_GET(num_nodes);
	 MESSIAH_GET(node_log);

	 MESSIAH_GET(nodeLogElement);
	 MESSIAH_GET(nodeGetElement);
	 MESSIAH_GET(nodeGetFirst);
	 MESSIAH_GET(nodeGetLast);
	 MESSIAH_GET(nodeSearchElement);
	 MESSIAH_GET(nodeClearElement);
	 MESSIAH_GET(nodeClearAllElements);

	 MESSIAH_GET(nodeObjectCreate);
	 MESSIAH_GET(nodeObjectRename);
	 MESSIAH_GET(nodeObjectNameGet);
	 MESSIAH_GET(nodeObjectPathGet);
	 MESSIAH_GET(nodeObjectCreatePoint);
	 MESSIAH_GET(nodeObjectGetPoint);
	 MESSIAH_GET(nodeObjectGetFilePoint);
	 MESSIAH_GET(nodeObjectNumPoints);
	 MESSIAH_GET(nodeObjectCreateSurface);
	 MESSIAH_GET(nodeObjectNumSurfaces);
	 MESSIAH_GET(nodeObjectSurfaceSet);
	 MESSIAH_GET(nodeObjectSurfaceNameGet);
	 MESSIAH_GET(nodeObjectCreatePoly);
	 MESSIAH_GET(nodeObjectNumPolygons);
	 MESSIAH_GET(nodeObjectGetPolygon);
	 MESSIAH_GET(nodeObjectAppend);
	 MESSIAH_GET(nodeObjectEnd);
	 MESSIAH_GET(nodeObjectRebuild);

	 MESSIAH_GET(nodeObjectGetMotion);
	 MESSIAH_GET(nodeObjectSetMotion);
	 MESSIAH_GET(nodeObjectGetWorldPos);
	 MESSIAH_GET(nodeObjectGetWorldRot);
}

