#include "MH_NodeObject.h"


// ===============================================================
// Create
// ===============================================================
MH_NodeObject *	MH_NodeObject::Create(char *name, int type, int flags)
{
	if( !nodeObjectCreate )
		return 0;

	MH_NodeObject *no = new MH_NodeObject;
	int	messiahObj = nodeObjectCreate(name, type, flags);

	if(!messiahObj)
	{
		delete no;
		return 0;
	}

	no->_messiahObj = messiahObj;
	return no;
}

// ===============================================================
// Naming
// ===============================================================
int		MH_NodeObject::Rename(char *name, int flags)
{
	if( !nodeObjectRename )
		return 0;

	return nodeObjectRename( this->MessiahObj(), name, flags );
}

int		MH_NodeObject::GetName(char *name, int buffer_size)
{
	if( !nodeObjectNameGet )
		return 0;

	return nodeObjectNameGet( this->MessiahObj(), name, buffer_size );
}

// ===============================================================
// Append / End / Rebuild
// ===============================================================
void	MH_NodeObject::Append(int flags)
{
	if( !nodeObjectAppend )
		return;

	nodeObjectAppend( this->MessiahObj(), flags );
}

void	MH_NodeObject::End(int flags)
{
	if( !nodeObjectEnd )
		return;

	nodeObjectEnd( this->MessiahObj(), flags );
}

void	MH_NodeObject::Rebuild(int flags)
{
	if( !nodeObjectRebuild )
		return;

	nodeObjectRebuild( this->MessiahObj(), flags );
}

// ===============================================================
// Vertex Ops
// ===============================================================
int		MH_NodeObject::CreatePoint(double x, double y, double z)
{
	if( !nodeObjectCreatePoint )
		return 0;

	return nodeObjectCreatePoint( this->MessiahObj(), x, y, z );
}

int		MH_NodeObject::GetPoint(int index, double *x, double *y, double *z)
{
	if( !nodeObjectGetPoint )
		return 0;

	return nodeObjectGetPoint( this->MessiahObj(), index, x, y, z );
}

int		MH_NodeObject::SetPoint(int index, double x, double y, double z)
{
	if( !nodeObjectSetPoint )
		return 0;

	return nodeObjectSetPoint( this->MessiahObj(), index, x, y, z );
}

int		MH_NodeObject::NumPoints()
{
	if( !nodeObjectNumPoints )
		return 0;

	return nodeObjectNumPoints( this->MessiahObj() );
}

// ===============================================================
// Surface Ops
// ===============================================================
int		MH_NodeObject::CreateSurface(char *name)
{
	if( !nodeObjectCreateSurface )
		return -1;

	return nodeObjectCreateSurface( this->MessiahObj(), name );
}

void	MH_NodeObject::SetSurface(int i, char *param, void *data)
{
	if( !nodeObjectSurfaceSet )
		return;

	nodeObjectSurfaceSet( this->MessiahObj(), i, param, data );
}

int		MH_NodeObject::GetSurface(int i, char *param, void *data)
{
	if( !nodeObjectSurfaceGet )
		return 0;

	return nodeObjectSurfaceGet(this->MessiahObj(), i, param, data);
}

int		MH_NodeObject::NumSurfaces()
{
	if( !nodeObjectNumSurfaces )
		return 0;

	return nodeObjectNumSurfaces(this->MessiahObj());
}

// ===============================================================
// Polygon Ops
// ===============================================================
void	MH_NodeObject::CreatePoly(int numPoints, int *vertList, unsigned short surfaceId, int flags)
{
	if( !nodeObjectCreatePoly )
		return;

	nodeObjectCreatePoly( this->MessiahObj(), numPoints, vertList, surfaceId, flags );
}

int		MH_NodeObject::NumPolys()
{
	if( !nodeObjectNumPolygons )
		return 0;

	return nodeObjectNumPolygons(this->MessiahObj());
}

int		MH_NodeObject::GetPoly(int i, int *point_IDs, int array_size, int *num_points, int *surface_ID)
{
	if( !nodeObjectGetPolygon )
		return 0;
	
	return nodeObjectGetPolygon(this->MessiahObj(), i, point_IDs, array_size, num_points, surface_ID);
}

// ===============================================================
// Motion Ops
// ===============================================================
void	MH_NodeObject::GetMotion(double channels[], double time)
{
	if( !nodeObjectGetMotion )
		return;

	nodeObjectGetMotion( this->MessiahObj(), channels, time );
}

void	MH_NodeObject::SetMotion(double channels[])
{
	if( !nodeObjectSetMotion )
		return;

	nodeObjectSetMotion( this->MessiahObj(), channels);
}

void	MH_NodeObject::GetWorldPos(double channels[], double time)
{
	if( !nodeObjectGetWorldPos )
		return;

	nodeObjectGetWorldPos( this->MessiahObj(), channels, time);
}

void	MH_NodeObject::GetWorldRot(double channels[], double time)
{
	if( !nodeObjectGetWorldRot )
		return;

	nodeObjectGetWorldRot( this->MessiahObj(), channels, time);
}