#include "MH_SystemWIN32.h"

#include "messiahHOST.h"
#include <string.h>
#include <stdlib.h>

extern char _messiahDir[_MAX_PATH];

bool		MH_SystemWIN32::_loadMessiahHost()
{
	HMODULE				hostmodule;
	char				libpath[_MAX_PATH], curdir[_MAX_PATH];
	int					i;

	if (this->_messiahlib) return true; //library is already loaded

	hostmodule = GetModuleHandle( this->_hostModuleName.c_str() ); 
	GetModuleFileName(hostmodule, curdir, _MAX_PATH); 

	//Path to scan for messiahHOST--------------------------------------
	i = strlen(curdir);
	curdir[i-this->_hostModuleName.size()] = '\0';
	strcpy( _messiahDir, curdir);

	sprintf(libpath,"%s%s",curdir, MESSIAH_MODULE_NAME );


	//load messiahHOST--------------------------------------------------
	if (this->_messiahlib = LoadLibrary(libpath))
	{
		if (messiahGlobal = ( MessiahGlobalFunc ) ::GetProcAddress(this->_messiahlib, "messiahGlobal"))
		{

		}
		else
		{
			::FreeLibrary(this->_messiahlib);
			this->_messiahlib = NULL;
			return false;
		}

		return true;
	}

	return false;
}

bool		MH_SystemWIN32::_unloadMessiahHost()
{
	int retval = 0;

	if( this->_messiahlib )
	{
		retval = ::FreeLibrary( this->_messiahlib );
		this->_messiahlib = 0;
	}

	return retval!=0;
}