// ============				messiahNode.h			==============
//
// Copyright (C) 2002 pmG Worldwide LLC. All Rights Reserved.
//
// ===============================================================
//
// Class Name: messiahNode
//
// ===============================================================
//
// Class Description:
//
// This class is a Maya Dependancy Graph Node. One messiahNode 
// will exist in each scene that maintains a connection to messiah.
// When the node is saved to disk it will contain the embedded messiah
// scene file needed to re-establish the connection.
//
// ===============================================================
//
// Version History:
//
// Written By: Ron Griswold
// Date: 4/28/2002
//
// Revised By:
// Date: 
//
// ===============================================================
#ifndef MM_MESSIAHNODE
#define MM_MESSIAHNODE

#include "ErrorCheck.h"
#include "Params.h"

#include <maya/MPxNode.h>

class messiahNode : public MPxNode
{
public:
	/*CST*/				messiahNode();
	/*DST*/				~messiahNode(); 

	MStatus				shouldSave(MPlug const &plug, bool &ret);

	static  void*		creator();
	static  MStatus		initialize();

	static	MTypeId		id;

	static	MObject		fxsBuffer;
	static  MObject		scaleFactor;
private:

};


#endif

