#include "c4d_basekey.h"
#include "c4d_basesequence.h"
#include "c4d_basetrack.h"
#include "c4d_baseobject.h"

void BaseSequence::SetData(const BaseContainer &bc)
{
	if (!bc.Get()) return;
	C4DOS.Bq->SetData(this,bc.Get());
}

BaseContainer BaseSequence::GetData(void)
{
	BaseContainer bc;
	if (!bc.Get()) return BaseContainer();
	C4DOS.Bq->GetData(this,bc.Get());
	return bc;
}

BaseObject *BaseSequence::GetObject(void)
{
	BaseTrack *bs=GetTrack();
	if (bs) return bs->GetObject(); else return NULL;
}

BaseDocument *BaseSequence::GetDocument(void)
{
	BaseObject *bo=GetObject();
	if (bo) return bo->GetDocument(); else return NULL;
}

BaseSequence *BaseSequence::GetClone(LONG flags)
{
	return C4DOS.Bq->GetClone(this,flags);
}

Bool BaseSequence::CopyTo(BaseSequence *dest, LONG flags)
{
	return C4DOS.Bq->CopyTo(this,dest,flags);
}

Bool BaseSequence::Edit(void)
{
	return C4DOS.Bq->Edit(this);
}

void BaseSequence::SetT1(const BaseTime &time)
{
	C4DOS.Bq->SetT1(this,time);
}

BaseTime BaseSequence::GetT1(void)
{
	return C4DOS.Bq->GetT1(this);
}

void BaseSequence::SetT2(const BaseTime &time)
{
	C4DOS.Bq->SetT2(this,time);
}

BaseTime BaseSequence::GetT2(void)
{
	return C4DOS.Bq->GetT2(this);
}

void BaseSequence::SetT3(const BaseTime &time)
{
	C4DOS.Bq->SetT3(this,time);
}

BaseTime BaseSequence::GetT3(void)
{
	return C4DOS.Bq->GetT3(this);
}

void BaseSequence::SetSoft(Bool b)
{
	C4DOS.Bq->SetSoft(this,b);
}

Bool BaseSequence::GetSoft(void)
{
	return C4DOS.Bq->GetSoft(this);
}

void BaseSequence::SetTimeMode(LONG b)
{
	C4DOS.Bq->SetTimeMode(this,b);
}

LONG BaseSequence::GetTimeMode(void)
{
	return C4DOS.Bq->GetTimeMode(this);
}

void BaseSequence::SetLeftInfluence(Bool b)
{
	C4DOS.Bq->SetLeftInfluence(this,b);
}

Bool BaseSequence::GetLeftInfluence(void)
{
	return C4DOS.Bq->GetLeftInfluence(this);
}

void BaseSequence::SetRightInfluence(Bool b)
{
	C4DOS.Bq->SetRightInfluence(this,b);
}

Bool BaseSequence::GetRightInfluence(void)
{
	return C4DOS.Bq->GetRightInfluence(this);
}

void BaseSequence::SetV0(Real r)
{
	C4DOS.Bq->SetV0(this,r);
}

Real BaseSequence::GetV0(void)
{
	return C4DOS.Bq->GetV0(this);
}

void BaseSequence::SetS0(Real r)
{
	C4DOS.Bq->SetS0(this,r);
}

Real BaseSequence::GetS0(void)
{
	return C4DOS.Bq->GetS0(this);
}

void BaseSequence::FlushAllKeys(void)
{
	C4DOS.Bq->FlushAllKeys(this);
}

void BaseSequence::FlushAllTimeKeys(void)
{
	C4DOS.Bq->FlushAllTimeKeys(this);
}

LONG BaseSequence::GetKeyCount(void)
{
	return C4DOS.Bq->GetKeyCount(this);
}

LONG BaseSequence::GetTimeKeyCount(void)
{
	return C4DOS.Bq->GetTimeKeyCount(this);
}

BaseKey	*BaseSequence::FindKey(const BaseTime &time)
{
	return C4DOS.Bq->FindKey(this,time);
}

BaseTime BaseSequence::GetLeft(void)
{
	return C4DOS.Bq->GetLeft(this);
}

BaseTime BaseSequence::GetRight(void)
{
	return C4DOS.Bq->GetRight(this);
}

BaseKey *BaseSequence::GetFirstKey(void)
{
	return C4DOS.Bq->GetFirstKey(this);
}

BaseKey *BaseSequence::GetFirstTimeKey(void)
{
	return C4DOS.Bq->GetFirstTimeKey(this);
}

Bool BaseSequence::InsertKey(BaseKey *bk)
{
	return C4DOS.Bq->InsertKey(this,bk);
}

Bool BaseSequence::InsertTimeKey(BaseKey *bk)
{
	return C4DOS.Bq->InsertTimeKey(this,bk);
}

String FolderSequence::GetName(void) 
{ 
	String str; 
	if (!str.Get()) return String(); 
	C4DOS.Bq->GetName(this,str.Get()); 
	return str; 
}

void FolderSequence::SetName(const String &name) 
{ 
	C4DOS.Bq->SetName(this,name.Get()); 
}

BaseObject *FolderSequence::GetFirstObject(void)
{
	return C4DOS.Bq->GetFirstObject(this);
}

void FolderSequence::InsertObject(BaseObject *op, BaseObject *parent, BaseObject *pred)
{
	C4DOS.Bq->InsertObject(this,op,parent,pred);
}

BaseSequence *AllocSequence(LONG type, LONG subtype)
{
	return C4DOS.Bq->Alloc(type,subtype);
}

BaseSound *SoundSequence::GetSound(void) 
{ 
	return C4DOS.Bq->GetSound(this);
}

void SoundSequence::SetSound(BaseSound *bs) 
{ 
	C4DOS.Bq->SetSound(this,bs);
}

LONG PluginSequence::GetPluginID(void)
{
	return C4DOS.Bq->GetPluginID(this);
}

void *PluginSequence::GetPluginData(void)
{
	return C4DOS.Bq->GetPluginData(this);
}

void PluginSequence::SetPluginData(void *mem)
{
	C4DOS.Bq->SetPluginData(this,mem);
}
