#include "c4d_memory.h"
#include "c4d_basetag.h"
#include "c4d_basecontainer.h"

class BaseSelect;

BaseTag *BaseTag::GetClone(LONG flags)
{
	return C4DOS.Tg->GetClone(this,flags);	
}	

Bool BaseTag::CopyTo(BaseTag *dest, LONG flags)
{
	return C4DOS.Tg->CopyTo(this,dest,flags);	
}	

LONG BaseTag::GetTagInfo(void)
{
	return C4DOS.Tg->GetTagInfo(this);	
}	

Bool BaseTag::Edit(void)
{
	return C4DOS.Tg->Edit(this);	
}	

void BaseTag::SetData(const BaseContainer &bc)
{
	if (!bc.Get()) return;
	C4DOS.Tg->SetData(this,bc.Get());
}

BaseContainer BaseTag::GetData(void)
{
	BaseContainer bc;
	if (!bc.Get()) return BaseContainer();
	C4DOS.Tg->GetData(this,bc.Get());
	return bc;
}

void BaseTag::GetIcon(IconData *dat)
{
	C4DOS.Tg->GetIcon(this,dat);
}

LONG VariableTag::GetDataCount(void)
{
	return C4DOS.Tg->GetDataCount(this);	
}	

LONG VariableTag::GetDataSize(void)
{
	return C4DOS.Tg->GetDataSize(this);	
}	

void *VariableTag::GetDataAddress(void)
{
	return C4DOS.Tg->GetDataAddress(this);	
}	

BaseTag *AllocTag(LONG type, LONG subtype, LONG count)
{
	return C4DOS.Tg->Alloc(type,subtype,count);
}

BaseSelect *SelectionTag::GetBaseSelect(void)
{
	return C4DOS.Tg->GetBaseSelect(this);
}

Vector TextureTag::GetPos(void)
{
	return C4DOS.Tx->GetPos(this);
}

Vector TextureTag::GetScale(void)
{
	return C4DOS.Tx->GetScale(this);
}

Vector TextureTag::GetRot(void)
{
	return C4DOS.Tx->GetRot(this);
}

Matrix TextureTag::GetMl(void)
{
	return C4DOS.Tx->GetMl(this);
}

Matrix TextureTag::GetMln(void)
{
	return C4DOS.Tx->GetMln(this);
}

void TextureTag::SetPos(const Vector &v)
{
	C4DOS.Tx->SetPos(this,v);
}

void TextureTag::SetScale(const Vector &v)
{
	C4DOS.Tx->SetScale(this,v);
}

void TextureTag::SetRot(const Vector &v)
{
	C4DOS.Tx->SetRot(this,v);
}

void TextureTag::SetMl(const Matrix &m)
{
	C4DOS.Tx->SetMl(this,m);
}

BaseMaterial *TextureTag::GetMaterial(void)
{
	return C4DOS.Tx->GetMaterial(this);
}

void TextureTag::SetMaterial(BaseMaterial *mat)
{
	C4DOS.Tx->SetMaterial(this,mat);
}

BaseMaterial *TextureTag::GetSecondMaterial(Real *fade)
{
	return C4DOS.Tx->GetSecondMaterial(this,fade);
}

void TextureTag::SetSecondMaterial(BaseMaterial *mat, Real fade)
{
	C4DOS.Tx->SetSecondMaterial(this,mat,fade);
}

BaseMaterial *TextureTag::GetInterpolatedMaterial(BaseDocument *doc)
{
	return C4DOS.Tx->GetInterpolatedMaterial(doc,this);
}

Bool StickTextureTag::Record(BaseObject *op, Bool always)
{
	return C4DOS.Tg->Record(this,op,always);
}

LONG PluginTag::GetPluginID(void)
{
	return C4DOS.Tg->GetPluginID(this);
}

void *PluginTag::GetPluginData(void)
{
	return C4DOS.Tg->GetPluginData(this);
}

void PluginTag::SetPluginData(void *mem)
{
	C4DOS.Tg->SetPluginData(this,mem);
}
