#include <string.h>
#include "c4d_memory.h"
#include "operatingsystem.h"

void _GeFree(void **Daten)
{
	if (*Daten)
	{
		C4DOS.Ge->Free(*Daten);
	}
	*Daten=0;
}

void ClearMem(void *d, LONG size, LONG value)
{
	memset(d,value,size);
}

void CopyMem(void *s, void *d, LONG size)
{
	memcpy(d,s,size);
}

#ifdef __MAC
#include <size_t.h>
#if defined(__cplusplus) && defined(_MSL_USING_NAMESPACE)
	using namespace std;
#endif

void* operator new(size_t s)
{
	return C4DOS.Ge->Alloc(s<1?1:s);
}

void* operator new[](size_t s)
{
	return C4DOS.Ge->Alloc(s<1?1:s);
}

void operator delete(void *p)
{
	void *temp=p;
	C4DOS.Ge->Free(temp);
}

void operator delete[](void *p)
{
	void *temp=p;
	C4DOS.Ge->Free(temp);
}
#else
void* operator new(unsigned int s)
{
	return C4DOS.Ge->Alloc(s<1?1:s);
}

void* operator new[](unsigned int s)
{
	return C4DOS.Ge->Alloc(s<1?1:s);
}

void operator delete(void *p)
{
	void *temp=p;
	C4DOS.Ge->Free(temp);
}

void operator delete[](void *p)
{
	void *temp=p;
	C4DOS.Ge->Free(temp);
}
#endif

MemoryPool *AllocMemoryPool(LONG block_size)
{
	return C4DOS.Pl->Alloc(block_size);
}

void FreeMemoryPool(MemoryPool *&pool)
{
	if (pool) C4DOS.Pl->Free(pool);
	pool=NULL;
}

void *MemoryPool::Alloc(LONG size, Bool clear)
{
	return C4DOS.Pl->AllocElement(this,size,clear);
}

void MemoryPool::Free(void *mem, LONG size)
{
	C4DOS.Pl->FreeElement(this,mem,size);
}

void *MemoryPool::AllocS(LONG size, Bool clear)
{
	return C4DOS.Pl->AllocElementS(this,size,clear);
}

void MemoryPool::FreeS(void *mem)
{
	C4DOS.Pl->FreeElementS(this,mem);
}
